﻿using System.Windows;
using System.Windows.Controls;

namespace TestProject;

/// <summary>
/// 중단 버튼
/// </summary>
public class StopButton : Button
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Dependency Property
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Public

    #region 코너 반경 속성 - CornerRadiusProperty

    /// <summary>
    /// 코너 반경 속성
    /// </summary>
    public static readonly DependencyProperty CornerRadiusProperty = DependencyProperty.Register
    (
        "CornerRadius",
        typeof(CornerRadius),
        typeof(StopButton),
        new PropertyMetadata(new CornerRadius(5))
    );

    #endregion
    #region 아이콘 너비 속성 - IconWidthProperty

    /// <summary>
    /// 아이콘 너비 속성
    /// </summary>
    public static readonly DependencyProperty IconWidthProperty = DependencyProperty.Register
    (
        "IconWidth",
        typeof(double),
        typeof(StopButton),
        new PropertyMetadata(14.0)
    );

    #endregion
    #region 아이콘 높이 속성 - IconHeightProperty

    /// <summary>
    /// 아이콘 높이 속성
    /// </summary>
    public static readonly DependencyProperty IconHeightProperty = DependencyProperty.Register
    (
        "IconHeight",
        typeof(double),
        typeof(StopButton),
        new PropertyMetadata(14.0)
    );

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Property
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 코너 반경 - CornerRadius

    /// <summary>
    /// 코너 반경
    /// </summary>
    public CornerRadius CornerRadius
    {
        get => (CornerRadius)GetValue(CornerRadiusProperty);
        set => SetValue(CornerRadiusProperty, value);
    }

    #endregion
    #region 아이콘 너비 - IconWidth

    /// <summary>
    /// 아이콘 너비
    /// </summary>
    public double IconWidth
    {
        get => (double)GetValue(IconWidthProperty);
        set => SetValue(IconWidthProperty, value);
    }

    #endregion
    #region 아이콘 높이 - IconHeight

    /// <summary>
    /// 아이콘 높이
    /// </summary>
    public double IconHeight
    {
        get => (double)GetValue(IconHeightProperty);
        set => SetValue(IconHeightProperty, value);
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Static

    #region 생성자 - StopButton()

    /// <summary>
    /// 생성자
    /// </summary>
    static StopButton()
    {
        DefaultStyleKeyProperty.OverrideMetadata(typeof(StopButton), new FrameworkPropertyMetadata(typeof(StopButton)));
    }

    #endregion

    ////////////////////////////////////////////////////////////////////////////////////////// Instance
    //////////////////////////////////////////////////////////////////////////////// Public

    #region 생성자 - StopButton

    /// <summary>
    /// 생성자
    /// </summary>
    public StopButton() : base()
    {
        Content = "Stop";
    }

    #endregion
}